<?php
$dataset = 'delicious';

$fIn = fopen($dataset.'.gph', 'r') or die("Cannot read input");
$fOut = fopen($dataset.'.uno', 'w') or die("Cannot read output");

// Read all
$data = array();
$degrees = array();
fgets($fIn); // skip first line
while($line = fgets($fIn)) {
	$row = explode(' ', trim($line));
	array_shift($row); // first is node id
	$data[] = $row;
	$degrees[] = count($row);
}

// Sort by degree descending
arsort($degrees);

// Create id mapping
$nid = 0;
$mapping = $degrees;
foreach($mapping as $id => $degree) {
	$mapping[$id] = $nid;
	$nid++;
}

// Output all
$newNode = 0;
foreach($degrees as $node => $degree) {	
	$edges = $data[$node];
	
	// remove half of them
	foreach($edges as $k => $edgeTo)
		if($mapping[$edgeTo] <= $newNode)
			unset($edges[$k]);
		else
			$edges[$k] = $mapping[$edgeTo];
	
	sort($edges);
	fputs($fOut, implode(',', $edges)."\n");

	$newNode++;
}

fclose($fIn);
fclose($fOut);
?>