<?php
$dataset = 'adjnoun';

$fIn = fopen($dataset.'.gml', 'r') or die("Cannot read input");
$fOut = fopen($dataset.'.uno', 'w') or die("Cannot write output");
$fMap = fopen($dataset.'.map', 'w') or die("Cannot write mapping");
$fDegrees = fopen($dataset.'-degrees.txt', 'w') or die("Cannot write degrees");

// Read index
$index = array();
$line = '';
while($line!='node')
	$line = trim(fgets($fIn));
do {
	fgets($fIn); // [
	list($dummy,$id) = explode(' ',trim(fgets($fIn)));
	$line = trim(fgets($fIn));
	if($line != ']') {
		list($dummy,$label) = explode(' ',$line);
		$index[$id] = $label;
		//echo $id."=".$label."\n";
		$line = trim(fgets($fIn));
		while($line != ']')
			$line = trim(fgets($fIn));
	}
	$line = trim(fgets($fIn)); // node or edge
	
} while($line!='edge');

// Read adjacency matrix
$data = array();
do {
	fgets($fIn); // [
	list($dummy,$from) = explode(' ',trim(fgets($fIn)));
	list($dummy,$to) = explode(' ',trim(fgets($fIn)));
	$line = '';
	while($line != ']')
		$line = trim(fgets($fIn));
	$line = trim(fgets($fIn)); // edge or ]

	if(!isset($data[$from]))
		$data[$from] = array();
	$data[$from][] = $to;
	if(!isset($data[$to]))
		$data[$to] = array();
	$data[$to][] = $from;
	
} while($line=='edge');

// Count degrees and sort
$degrees = array();
foreach($data as $id => $row)
	$degrees[$id] = count($row);
arsort($degrees);

// Create and output id mapping
$nid = 0;
$mapping = $degrees;
foreach($mapping as $id => $degree) {
	$mapping[$id] = $nid;
	fputs($fMap, $id."\n");
	fputs($fDegrees, $degree."\n");
	$nid++;
}

// Output data and index
$hasIndex = count($index) > 0;
if($hasIndex)
	$fIndex = fopen($dataset.'_index.txt', 'w') or die("Cannot write output");
$newNode = 0;
foreach($degrees as $node => $degree) {	
	$edges = $data[$node];
	
	// remove half of them
	foreach($edges as $k => $edgeTo)
		if($mapping[$edgeTo] <= $newNode)
			unset($edges[$k]);
		else
			$edges[$k] = $mapping[$edgeTo];
	
	sort($edges);
	fputs($fOut, implode(',', $edges)."\n");
	
	if($hasIndex)
		fputs($fIndex, $newNode . ': ' . $index[$node] . "\n");

	$newNode++;
}

fclose($fIn);
fclose($fOut);
fclose($fMap);
fclose($fDegrees);
if($hasIndex)
	fclose($fIndex);
?>