<?php
// Also works for directed graphs such as wiki-vote, and makes them undirected

$dataset = 'web-google';
#$dataset = 'wiki-vote';

$fIn = fopen($dataset.'.txt', 'r') or die("Cannot read input");
$fOut = fopen($dataset.'.uno', 'w') or die("Cannot read output");

// Construct friendship graph in memory
$data = array();
while(!feof($fIn)) {
	$line = trim(fgets($fIn, 5000));
	if(strlen($line) > 2) {
		if($line[0] == '#')
			continue;
		list($u1,$u2) = explode("\t", $line);
		if($u1 != $u2) {
			if(!isset($data[$u1]) || !in_array($u2, $data[$u1])) {
				$data[$u1][] = $u2;
				$data[$u2][] = $u1;
			}
		}
	}
}
//print_r($links);

// Count degrees
$degrees = array();
foreach($data as $u1 => $links)
	$degrees[$u1] = count($links);

// Sort by degree descending
arsort($degrees);

// Create id mapping
$nid = 0;
$mapping = $degrees;
foreach($mapping as $id => $degree) {
	$mapping[$id] = $nid;
	$nid++;
}

// Output all
$newNode = 0;
foreach($degrees as $node => $degree) {	
	$edges = $data[$node];
	
	// remove half of them
	foreach($edges as $k => $edgeTo)
		if($mapping[$edgeTo] <= $newNode)
			unset($edges[$k]);
		else
			$edges[$k] = $mapping[$edgeTo];
	
	sort($edges);
	fputs($fOut, implode(',', $edges)."\n");

	$newNode++;
}

fclose($fIn);
fclose($fOut);
?>