#ifndef __ITERATIVETOP1COLLECTION_H
#define __ITERATIVETOP1COLLECTION_H

#include "PatternCollection.h"

class BASS_API IterativeTop1Collection : public PatternCollection {
public:
	IterativeTop1Collection(Config *config, Database *db, PatternFile *pFile);
	virtual ~IterativeTop1Collection();

	// Modify collection
	virtual void		Add(ItemSet *is);
	virtual ItemSet		**GetPatterns()					{ return mPatterns; }
	virtual ItemSet		*GetPattern(const uint32 num)   { return mPatterns[num]; }
	virtual void		NextIteration();
	// At the end of the search, give the collection the opportunity to e.g. save
	virtual void		Finalize();

	virtual uint32		GetNumIterations() { return mNumIterations; }

	virtual double		GetMinThreshold() { return mBestLambda; }

	// Compute more statistics
	virtual void		WritePatternDetails(const string &filename);
	virtual void		ComputeGlobalStats();

	// Check properties of instances
	virtual bool		IsLoaded() { return true; } // all in memory

protected:
	// Helpers
	void				WritePatternWithDetails(FILE *file, ItemSet *is);

	// Parameters
	uint32		mNumIterations;

	// Structures
	ItemSet		*mBestPattern;
	double		mBestLambda;
	ItemSet		**mPatterns;
};
#endif // __ITERATIVETOP1COLLECTION_H
