#include <Config.h>

#include "../Bass.h"
#include "../db/Database.h"
#include "../itemstructs/PatternFile.h"

#include "DirectlyToFileCollection.h"
#include "IterativeTop1Collection.h"
#include "TopKCollection.h"

#include "PatternCollection.h"

PatternCollection::PatternCollection(Database *db, PatternFile *pFile) {
	mDatabase = db;
	mPatternFile = pFile;

	mNumPatterns = 0;
}
PatternCollection::~PatternCollection() {
	delete mPatternFile;
}
PatternCollection* PatternCollection::Create(Config *config, Database *db, PatternFile *pFile) {
	string mode = config->Read<string>("mine");
	if(mode.compare("file") == 0)
		return new DirectlyToFileCollection(config, db, pFile);
	if(mode.compare("topk") == 0)
		return new TopKCollection(config, db, pFile);
	if(mode.compare("iterative") == 0)
		return new IterativeTop1Collection(config, db, pFile);
	THROW("Unknown type of pattern collection.");
}
