#ifndef __TOPKCOLLECTION_H
#define __TOPKCOLLECTION_H

#include "PatternCollection.h"

class BASS_API TopKCollection : public PatternCollection {
public:
	TopKCollection(Config *config, Database *db, PatternFile *pFile);
	TopKCollection(const uint32 k, Database *db);
	virtual ~TopKCollection();

	// Modify collection
	virtual void		Add(ItemSet *is);
	virtual ItemSet		**GetPatterns()   { return mPatterns; }

	// At the end of the search, give the collection the opportunity to e.g. save
	virtual void		Finalize();

	virtual double		GetMinThreshold() { return mNumPatterns<mK ? DOUBLE_MIN_VALUE : mMinThreshold; }

	// Compute more statistics
	virtual void		WritePatternDetails(const string &filename);
	virtual void		ComputeGlobalStats();

	// Check properties of instances
	virtual bool		IsLoaded() { return true; } // all in memory

protected:
	// Helpers
	void				WritePatternWithDetails(FILE *file, ItemSet *is);

	// Parameters
	uint32		mK;

	// Structures
	ItemSet		**mPatterns;
	double		mMinThreshold;
	uint32		mMinIdx;

	uint32		*mSetArray;
};
#endif // __TOPKCOLLECTION_H
