#ifndef __ISCFILE_H
#define __ISCFILE_H

#include <FileUtils.h>

#include "../BassApi.h"
#include "../itemstructs/ItemSet.h"

class Database;
class ItemSet;

#define ISCFILE_BUFFER_LENGTH 20000

class BASS_API PatternFile {
public:
	PatternFile(const string filename, Database *db);

	/* Closes file link and deletes the read buffer */
	virtual ~PatternFile();

	virtual void		WriteItemSet(ItemSet *is);
	virtual string		GetFileName() { return mFilename; }

protected:
	/* Opens a filehandle, remembers the filename */
	virtual void		OpenFile(const string &filename, const FileOpenType openType = FileReadable);
	/* Universal implementation of IscFile::Close() fpcloses the file */
	virtual void		CloseFile();
	/* Returns whether a file handle is open */
	virtual bool		IsOpen();

	int64				GetFileSize();

	FILE		*mFile;
	string		mFilename;

	Database	*mDatabase;

	uint32		*mSetArray;
};
#endif // __ISCFILE_H
