#ifndef __MAXENTMODEL_H
#define __MAXENTMODEL_H

#include <Bass.h>

class Config;
class Database;
class ItemSet;

class MaxEntModel {
public:
	MaxEntModel(Config *config, Database *db);
	virtual ~MaxEntModel();

	double probability(int nodea, int nodeb);
	void update(const uint32 *nodes, const uint32 numNodes, const uint32 numEdges);
	
protected:
	void makeUnique(vector<int>* sums, vector<int>& uniqueSums, vector<vector<int> >& indices);

	// Member variables
	Config		*mConfig;
	Database	*mDatabase;
	uint32		mNumNodes;
	double		mLargestLambda;
	double		mSmallestLambda;
    vector<double> mLambda;
    vector<set<const uint32> > mNodeToSolution;
    vector<double> mLambdaS;
};

#endif // __MAXENTMODEL_H
