#ifndef __BESTFIRSTSEARCH_H
#define __BESTFIRSTSEARCH_H

#include <queue>

#include "../Search.h"
#include <itemstructs/ItemSet.h>

struct ComparePatternsLambda : public std::binary_function<ItemSet*, ItemSet*, bool>
{
	bool operator()(const ItemSet* lhs, const ItemSet* rhs) const
	{
		return lhs->GetLambda() < rhs->GetLambda();
	}
};
struct ComparePatternsUpperBound : public std::binary_function<ItemSet*, ItemSet*, bool>
{
	bool operator()(const ItemSet* lhs, const ItemSet* rhs) const
	{
		return lhs->GetUpperBound() < rhs->GetUpperBound();
	}
};
//typedef priority_queue<ItemSet*, vector<ItemSet*>, ComparePatternsLambda> PatternQueue;
typedef priority_queue<ItemSet*, vector<ItemSet*>, ComparePatternsUpperBound> PatternQueue;

class BestFirstSearch : public Search {
public:
	BestFirstSearch(Config *config, Database *database, PatternCollection *patternCollection);
	virtual ~BestFirstSearch();

	// -- Virtual --
	virtual uint64				DoSearch();
	virtual void				LogParameters();
	virtual string				GetName()						{ return string("best"); }
	virtual bool				CanUseUpperBound()				{ return true; }

protected:

};

#endif // __BESTFIRSTSEARCH_H
