#ifndef __BETTERBESTFIRSTSEARCH_H
#define __BETTERBESTFIRSTSEARCH_H

#include <set>

#include "../Search.h"
#include <itemstructs/ItemSet.h>

//typedef list<ItemSet*> BetterPatternQueue;
struct CmpPatternsUpperBound : public std::binary_function<ItemSet*, ItemSet*, bool>
{
	bool operator()(const ItemSet* lhs, const ItemSet* rhs) const
	{
		return lhs->GetUpperBound() > rhs->GetUpperBound();
	}
};
typedef multiset<ItemSet*, CmpPatternsUpperBound> BetterPatternQueue;

class BetterBestFirstSearch : public Search {
public:
	BetterBestFirstSearch(Config *config, Database *database, PatternCollection *patternCollection);
	virtual ~BetterBestFirstSearch();

	// -- Virtual --
	virtual uint64				DoSearch();
	virtual void				LogParameters();
	virtual string				GetName()						{ return string("better-best"); }
	virtual bool				CanUseUpperBound()				{ return true; }

protected:
	BetterPatternQueue	*mQueue;

	// Maintaining the priority queue
	void		Insert(ItemSet *pattern);
	ItemSet*	GetNext();
	void		PruneQueue(double minInterestingness);
};

#endif // __BETTERBESTFIRSTSEARCH_H
