#ifndef __BOUNDEDBESTFIRSTSEARCH_H
#define __BOUNDEDBESTFIRSTSEARCH_H

#include "../Search.h"
#include <itemstructs/ItemSet.h>

typedef list<ItemSet*> BoundedPatternQueue;

class BoundedBestFirstSearch : public Search {
public:
	BoundedBestFirstSearch(Config *config, Database *database, PatternCollection *patternCollection);
	virtual ~BoundedBestFirstSearch();

	// -- Virtual --
	virtual uint64				DoSearch();
	virtual void				LogParameters();
	virtual string				GetName()						{ return string("bounded-best"); }
	virtual bool				CanUseUpperBound()				{ return true; }

protected:
	BoundedPatternQueue	*mQueue;
	uint32			mQueueSize;
	uint32			mMaxQueueSize;

	// Maintaining the priority queue
	void		Insert(ItemSet *pattern);
	ItemSet*	GetNext();
};

#endif // __BOUNDEDBESTFIRSTSEARCH_H
