#ifndef __HILLCLIMBER_H
#define __HILLCLIMBER_H

#include "../Search.h"

enum SeedMode {
	SEED_ALL = 1,
	SEED_UNIFORM,
	SEED_DEGREE,
	SEED_INTERESTINGNESS,
};

class Hillclimber : public Search {
public:
	Hillclimber(Config *config, Database *database, PatternCollection *patternCollection);
	virtual ~Hillclimber();

	// -- Virtual --
	virtual uint64				DoSearch();
	virtual void				LogParameters();
	virtual string				GetName()						{ return string("hillclimber"); }
	virtual uint32				GetNumRunsPerIteration()		{ return mNumRuns; }

protected:
	// Member variables
	uint32			mNumRuns;
	SeedMode		mSeedMode;
};

#endif // __HILLCLIMBER_H
